/*
**==============================================================================
**
** Copyright (c) Microsoft Corporation. All rights reserved. See file LICENSE
** for license information.
**
**==============================================================================
*/

/* A lexical scanner generated by flex */

/* Scanner skeleton version:
 * $Header: /home/daffy/u0/vern/flex/RCS/flex.skl,v 2.91 96/09/10 16:58:48 vern Exp $
 */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5

#include <stdio.h>


/* cfront 1.2 defines "c_plusplus" instead of "__cplusplus" */
#ifdef c_plusplus
#ifndef __cplusplus
#define __cplusplus
#endif
#endif


#ifdef __cplusplus

#include <stdlib.h>
#include <unistd.h>

/* Use prototypes in function declarations. */
#define YY_USE_PROTOS

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else   /* ! __cplusplus */

#if __STDC__

#define YY_USE_PROTOS
#define YY_USE_CONST

#endif  /* __STDC__ */
#endif  /* ! __cplusplus */

#ifdef __TURBOC__
 #pragma warn -rch
 #pragma warn -use
#include <io.h>
#include <stdlib.h>
#define YY_USE_CONST
#define YY_USE_PROTOS
#endif

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif


#ifdef YY_USE_PROTOS
#define YY_PROTO(proto) proto
#else
#define YY_PROTO(proto) ()
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN yy_start = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START ((yy_start - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart( yyin )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#define YY_BUF_SIZE 16384

typedef struct yy_buffer_state *YY_BUFFER_STATE;

extern int yyleng;
extern FILE *yyin, *yyout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

/* The funky do-while in the following #define is used to turn the definition
 * int a single C statement (which needs a semi-colon terminator).  This
 * avoids problems with code like:
 *
 *      if ( condition_holds )
 *              yyless( 5 );
 *      else
 *              do_something_else();
 *
 * Prior to using the do-while the compiler would get upset at the
 * "else" because it interpreted the "if" statement as being all
 * done when it reached the ';' after the yyless() call.
 */

/* Return all but the first 'n' matched characters back to the input stream. */

#define yyless(n) \
        do \
                { \
                /* Undo effects of setting up yytext. */ \
                *yy_cp = yy_hold_char; \
                YY_RESTORE_YY_MORE_OFFSET \
                yy_c_buf_p = yy_cp = yy_bp + n - YY_MORE_ADJ; \
                YY_DO_BEFORE_ACTION; /* set up yytext again */ \
                } \
        while ( 0 )

#define unput(c) yyunput( c, yytext_ptr )

/* The following is because we cannot portably get our hands on size_t
 * (without autoconf's help, which isn't available because we want
 * flex-generated scanners to compile on their own).
 */
typedef unsigned int yy_size_t;


struct yy_buffer_state
        {
        FILE *yy_input_file;

        char *yy_ch_buf;                /* input buffer */
        char *yy_buf_pos;               /* current position in input buffer */

        /* Size of input buffer in bytes, not including room for EOB
         * characters.
         */
        yy_size_t yy_buf_size;

        /* Number of characters read into yy_ch_buf, not including EOB
         * characters.
         */
        int yy_n_chars;

        /* Whether we "own" the buffer - i.e., we know we created it,
         * and can PAL_Realloc() it to grow it, and should PAL_Free() it to
         * delete it.
         */
        int yy_is_our_buffer;

        /* Whether this is an "interactive" input source; if so, and
         * if we're using stdio for input, then we want to use getc()
         * instead of fread(), to make sure we stop fetching input after
         * each newline.
         */
        int yy_is_interactive;

        /* Whether we're considered to be at the beginning of a line.
         * If so, '^' rules will be active on the next match, otherwise
         * not.
         */
        int yy_at_bol;

        /* Whether to try to fill the input buffer when we reach the
         * end of it.
         */
        int yy_fill_buffer;

        int yy_buffer_status;
#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
        /* When an EOF's been seen but there's still some text to process
         * then we mark the buffer as YY_EOF_PENDING, to indicate that we
         * shouldn't try reading from the input source any more.  We might
         * still have a bunch of tokens to match, though, because of
         * possible backing-up.
         *
         * When we actually see the EOF, we change the status to "new"
         * (via yyrestart()), so that the user can continue scanning by
         * just pointing yyin at a new input file.
         */
#define YY_BUFFER_EOF_PENDING 2
        };

static YY_BUFFER_STATE yy_current_buffer = 0;

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 */
#define YY_CURRENT_BUFFER yy_current_buffer


/* yy_hold_char holds the character lost when yytext is formed. */
static char yy_hold_char;

static int yy_n_chars;          /* number of characters read into yy_ch_buf */


int yyleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = (char *) 0;
static int yy_init = 1;         /* whether we need to initialize */
static int yy_start = 0;        /* start state number */

/* Flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a workaround ...
 */
static int yy_did_buffer_switch_on_eof;

void yyrestart YY_PROTO(( FILE *input_file ));

void yy_switch_to_buffer YY_PROTO(( YY_BUFFER_STATE new_buffer ));
void yy_load_buffer_state YY_PROTO(( void ));
YY_BUFFER_STATE yy_create_buffer YY_PROTO(( FILE *file, int size ));
void yy_delete_buffer YY_PROTO(( YY_BUFFER_STATE b ));
void yy_init_buffer YY_PROTO(( YY_BUFFER_STATE b, FILE *file ));
void yy_flush_buffer YY_PROTO(( YY_BUFFER_STATE b ));
#define YY_FLUSH_BUFFER yy_flush_buffer( yy_current_buffer )

YY_BUFFER_STATE yy_scan_buffer YY_PROTO(( char *base, yy_size_t size ));
YY_BUFFER_STATE yy_scan_string YY_PROTO(( yyconst char *yy_str ));
YY_BUFFER_STATE yy_scan_bytes YY_PROTO(( yyconst char *bytes, int len ));

static void *yy_flex_alloc YY_PROTO(( yy_size_t ));
static void *yy_flex_realloc YY_PROTO(( void *, yy_size_t ));
static void yy_flex_free YY_PROTO(( void * ));

#define yy_new_buffer yy_create_buffer

#define yy_set_interactive(is_interactive) \
        { \
        if ( ! yy_current_buffer ) \
                yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE ); \
        yy_current_buffer->yy_is_interactive = is_interactive; \
        }

#define yy_set_bol(at_bol) \
        { \
        if ( ! yy_current_buffer ) \
                yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE ); \
        yy_current_buffer->yy_at_bol = at_bol; \
        }

#define YY_AT_BOL() (yy_current_buffer->yy_at_bol)

typedef unsigned char YY_CHAR;
FILE *yyin = (FILE *) 0, *yyout = (FILE *) 0;
typedef int yy_state_type;
extern char *yytext;
#define yytext_ptr yytext

static yy_state_type yy_get_previous_state YY_PROTO(( void ));
static yy_state_type yy_try_NUL_trans YY_PROTO(( yy_state_type current_state ));
static int yy_get_next_buffer YY_PROTO(( void ));
static void yy_fatal_error YY_PROTO(( yyconst char msg[] ));

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
        yytext_ptr = yy_bp; \
        yyleng = (int) (yy_cp - yy_bp); \
        yy_hold_char = *yy_cp; \
        *yy_cp = '\0'; \
        yy_c_buf_p = yy_cp;

#define YY_NUM_RULES 67
#define YY_END_OF_BUFFER 68
static yyconst short int yy_accept[286] =
    {   0,
        0,    0,   68,   66,   65,   65,   43,   66,   66,   66,
       56,   57,   66,   64,   66,   66,   47,   48,   48,   62,
       63,   55,   53,   53,   53,   53,   53,   53,   53,   53,
       53,   53,   53,   53,   53,   53,   53,   53,   53,   58,
       59,   60,   61,   65,    0,   54,    0,    0,    0,   47,
       48,   48,   49,   41,   42,   51,   51,    0,   52,    0,
       48,   48,   53,   53,   38,   53,   53,   53,   53,   53,
       53,   53,   53,   53,   53,   53,   53,   37,   53,   53,
       53,   53,   53,   53,   53,   53,   53,   53,    0,   54,
       44,    0,   44,    0,    0,   50,   28,   53,   53,   53,

       53,   53,   53,   53,   53,   53,   53,   53,   53,   53,
       53,   53,   53,   53,   53,   18,   53,   53,   53,   53,
       53,   53,   53,   53,   53,    0,   45,    0,    0,   49,
       53,   53,   53,   53,   53,   53,   53,   53,   53,   53,
       53,   53,    3,   53,   53,   53,   53,   53,   53,   53,
       53,   53,   53,   53,   53,   53,    1,   53,    0,   46,
       53,   53,   53,   20,   53,   53,   53,    2,   53,   53,
       53,   53,   53,   53,   53,   53,   53,   53,   53,   53,
       19,   53,   53,   53,    5,   53,   53,   53,   53,   53,
       53,   53,    6,    0,   53,   53,   16,   53,   53,   53,

       29,   53,   53,   26,   39,   53,   53,   53,   13,   14,
       53,   53,    7,    9,   11,   17,   53,   53,   53,    8,
       10,   12,    0,   53,    4,   53,   53,   53,   53,   53,
       53,   53,   53,   53,   53,   53,   53,   53,   40,   53,
       15,   53,   53,   53,   36,   53,   24,   53,   53,   53,
       53,   53,   53,   53,   53,   53,   53,   27,   23,   25,
       53,   53,   53,   53,   53,   53,   53,   22,   32,   34,
       33,   53,   21,   53,   53,   53,   53,   53,   35,   53,
       53,   53,   30,   31,    0
    } ;

static yyconst int yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    2,    2,    3,
        1,    2,    2,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    4,    1,    5,    6,    7,    1,    1,    8,    9,
       10,   11,   12,   13,   12,   14,   15,   16,   17,   18,
       19,   20,   21,   22,   21,   23,   24,   25,   26,    1,
       27,    1,    1,    1,   28,   29,   30,   31,   32,   33,
       34,   35,   36,   37,   38,   39,   40,   41,   42,   43,
       44,   45,   46,   47,   48,   49,   38,   50,   51,   38,
       52,   53,   54,    1,   38,    1,   28,   55,   30,   31,

       32,   56,   34,   35,   36,   37,   38,   39,   40,   57,
       42,   43,   44,   58,   46,   59,   48,   49,   38,   50,
       51,   38,   60,    1,   61,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static yyconst int yy_meta[62] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    2,    1,    1,
        1,    3,    1,    4,    1,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    1,    1,    1,    6,    6,    6,
        6,    7,    6,    8,    8,    8,    8,    8,    8,    8,
        8,    8,    8,    8,    8,    8,    8,    8,    8,    8,
        8,    1,    1,    1,    6,    6,    8,    8,    8,    1,
        1
    } ;

static yyconst short int yy_base[296] =
    {   0,
        0,    0,  460,  461,   60,   63,  461,  416,    0,  405,
      461,  461,   54,  461,   56,   70,   72,  114,   86,  461,
      461,  461,   41,  415,   65,   69,   42,   78,    0,   66,
      424,  407,   91,   81,  406,  421,  112,   71,  416,  461,
      461,  461,  461,  108,   63,    0,  443,  144,  144,    0,
        0,    0,  418,  461,  461,  399,  128,  434,  461,    0,
        0,    0,    0,  396,  400,  403,  416,  415,  111,  396,
      413,  401,  411,   38,  125,  399,  400,    0,   95,  394,
      407,  149,  392,  132,  129,  139,  128,  139,  405,    0,
      461,  424,  423,    0,  418,    0,    0,  387,  389,  134,

      381,  394,  397,   96,  378,  374,  386,  134,  386,  381,
      387,  390,  374,  377,  376,  382,  139,  370,  157,  376,
      149,  363,  150,  378,  161,  375,  461,  400,  205,  214,
      377,  374,  388,  358,  192,  159,  364,  370,  359,  370,
      371,  356,    0,  367,  356,  363,  358,  190,  195,  196,
      361,  196,  201,  346,  188,  345,    0,  227,  350,  461,
      353,  360,  365,    0,  350,  346,  352,    0,  202,  355,
      204,  351,  205,  349,  210,  215,  362,  359,  346,  341,
        0,  354,  357,  354,    0,  339,  210,  342,  332,  348,
      351,  348,    0,  339,  338,  215,    0,  325,  332,  321,

        0,  215,  332,    0,    0,  216,  218,  325,    0,    0,
      225,  330,    0,    0,    0,    0,  331,  319,  329,    0,
        0,    0,  352,  220,    0,  323,  312,  304,  316,  319,
      318,  298,  316,  317,  226,  229,  318,  229,  461,  308,
        0,  284,  283,  267,    0,  233,    0,  235,  275,  274,
      274,  255,  272,  256,  265,  236,  242,    0,    0,    0,
      265,  258,  213,  255,  246,  244,  247,    0,    0,    0,
        0,  172,    0,  250,  174,  123,  118,  119,    0,   88,
       86,   82,    0,    0,  461,  305,  313,  318,  319,  323,
      327,  331,  332,  335,  340

    } ;

static yyconst short int yy_def[296] =
    {   0,
      285,    1,  285,  285,  285,  285,  285,  285,  286,  287,
      285,  285,  288,  285,  285,  285,  285,  285,   18,  285,
      285,  285,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  285,
      285,  285,  285,  285,  285,  290,  285,  285,  285,   17,
       18,   19,  291,  285,  285,   17,   17,  292,  285,  293,
       18,   19,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  285,  290,
      285,  285,  285,  294,  295,  293,  289,  289,  289,  289,

      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  285,  285,  294,  285,  285,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  285,  285,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  285,  289,  289,  289,  289,  289,  289,

      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  285,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  285,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,    0,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285

    } ;

static yyconst short int yy_nxt[523] =
    {   0,
        4,    5,    6,    5,    7,    8,    9,   10,   11,   12,
        4,   13,   14,   15,   16,   17,   18,   19,   19,   19,
       19,   19,   19,   19,   20,   21,   22,   23,   24,   25,
       26,   27,   28,   29,   29,   30,   29,   29,   29,   31,
       32,   33,   34,   35,   36,   37,   38,   39,   29,   29,
       29,   40,    4,   41,   24,   28,   32,   36,   38,   42,
       43,   44,   44,   44,   44,   44,   44,   49,  107,   50,
       51,   53,   53,   53,   53,   53,   53,   53,   53,   53,
       54,   64,   71,  108,   55,   49,   65,   56,   56,   57,
       57,   57,   57,   57,   58,   58,   69,   64,   71,   67,

       59,   62,   62,   68,   70,   72,   74,   89,   79,   44,
       44,   44,   86,  284,  285,   87,   73,  283,  282,   77,
       89,   60,   74,   78,  137,   80,   59,   49,   87,   61,
       61,   62,   62,   62,   62,   62,   62,   62,   80,  112,
      285,   83,   59,   57,   57,   77,   78,   84,   92,  281,
      137,   93,  112,  280,  279,  123,  285,  102,   85,   53,
       53,   53,   53,   53,   53,   53,   53,   53,   59,  102,
       85,  109,  119,  120,  121,  124,  115,  285,  133,  125,
      141,  116,  285,  109,  122,  150,  120,  166,  119,  154,
      156,  133,  141,   94,  117,  125,   92,  150,   92,   92,

       92,   92,   92,  152,  116,  154,  156,  158,  177,  278,
      276,  178,  182,  166,  183,  152,  188,  184,  185,  158,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  165,  179,
      180,  186,  188,  190,  203,  191,  201,  208,  192,  193,
      165,  205,  179,  180,  207,  225,  217,  186,  271,  201,
      203,  229,  231,  205,  232,  234,  240,  207,  217,  251,
      208,  225,  250,  229,  231,  253,  232,  258,  240,  259,
      267,  234,  268,  272,  250,  251,  273,  253,  274,  270,
      258,  275,  259,  267,  277,  269,  266,  265,  268,  264,

      263,  274,  273,  262,  275,  261,  260,  277,  257,  272,
       46,   46,   46,   47,  256,   47,   47,   47,   47,   47,
       47,   52,   52,   63,   63,   63,   63,   90,   90,   90,
       90,   53,  255,   53,   58,   58,   96,   96,   96,  128,
      128,  128,  130,  254,  130,  252,  249,  248,  247,  246,
      245,  244,  243,  242,  241,  239,  238,  237,  236,  235,
      233,  230,  228,  227,  226,  224,  223,  222,  221,  220,
      219,  218,  216,  215,  214,  213,  212,  211,  210,  209,
      206,  204,  202,  200,  199,  198,  197,  196,  195,  194,
      189,  187,  181,  176,  175,  174,  173,  172,  171,  170,

      169,  168,  167,  164,  163,  162,  161,  160,  159,  157,
      155,  153,  151,  149,  148,  147,  146,  145,  144,  143,
      142,  140,  139,  138,  136,  135,  134,  132,  131,  129,
      127,  127,  126,  118,  114,  113,  111,  110,  106,  105,
      104,  103,  101,  100,   99,   98,   97,   49,  285,   95,
       91,   88,   82,   81,   76,   75,   66,   48,   45,  285,
        3,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,

      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285
    } ;

static yyconst short int yy_chk[523] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    5,    5,    5,    6,    6,    6,   13,   74,   13,
       13,   15,   15,   15,   15,   15,   15,   15,   15,   15,
       16,   23,   27,   74,   16,   17,   23,   17,   17,   17,
       17,   17,   17,   17,   17,   17,   26,   23,   27,   25,

       17,   19,   19,   25,   26,   28,   30,   45,   34,   44,
       44,   44,   38,  282,   19,   38,   28,  281,  280,   33,
       45,   17,   30,   33,  104,   34,   17,   18,   38,   18,
       18,   18,   18,   18,   18,   18,   18,   18,   34,   79,
       19,   37,   18,   57,   57,   33,   33,   37,   48,  278,
      104,   48,   79,  277,  276,   87,   57,   69,   37,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   18,   69,
       37,   75,   84,   85,   86,   87,   82,   57,  100,   88,
      108,   82,   57,   75,   86,  117,   85,  136,   84,  121,
      123,  100,  108,   48,   82,   88,   48,  117,   48,   48,

       48,   48,   48,  119,   82,  121,  123,  125,  148,  275,
      272,  148,  152,  136,  152,  119,  155,  152,  152,  125,
      129,  129,  129,  129,  129,  129,  129,  129,  129,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  135,  149,
      150,  153,  155,  158,  171,  158,  169,  176,  158,  158,
      135,  173,  149,  150,  175,  196,  187,  153,  263,  169,
      171,  202,  206,  173,  207,  211,  224,  175,  187,  236,
      176,  196,  235,  202,  206,  238,  207,  246,  224,  248,
      256,  211,  257,  264,  235,  236,  265,  238,  266,  262,
      246,  267,  248,  256,  274,  261,  255,  254,  257,  253,

      252,  266,  265,  251,  267,  250,  249,  274,  244,  264,
      286,  286,  286,  287,  243,  287,  287,  287,  287,  287,
      287,  288,  288,  289,  289,  289,  289,  290,  290,  290,
      290,  291,  242,  291,  292,  292,  293,  293,  293,  294,
      294,  294,  295,  240,  295,  237,  234,  233,  232,  231,
      230,  229,  228,  227,  226,  223,  219,  218,  217,  212,
      208,  203,  200,  199,  198,  195,  194,  192,  191,  190,
      189,  188,  186,  184,  183,  182,  180,  179,  178,  177,
      174,  172,  170,  167,  166,  165,  163,  162,  161,  159,
      156,  154,  151,  147,  146,  145,  144,  142,  141,  140,

      139,  138,  137,  134,  133,  132,  131,  128,  126,  124,
      122,  120,  118,  116,  115,  114,  113,  112,  111,  110,
      109,  107,  106,  105,  103,  102,  101,   99,   98,   95,
       93,   92,   89,   83,   81,   80,   77,   76,   73,   72,
       71,   70,   68,   67,   66,   65,   64,   58,   56,   53,
       47,   39,   36,   35,   32,   31,   24,   10,    8,    3,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,

      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285
    } ;

static yy_state_type yy_last_accepting_state;
static char *yy_last_accepting_cpos;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
char *yytext;
#line 1 "mof.l"
#define INITIAL 0
/*
**==============================================================================
**
** mof.lex
**
**     This file defines a lexigraphical analyzer for the Managed Object Format
**     (MOF). See the BNF in the CIM Infrastructure Specification.
**
**==============================================================================
*/
#line 13 "mof.l"

/* Do not read from standard input */
#define YY_NEVER_INTERACTIVE 1
#define MOF_STACK_SIZE 32

#include "config.h"
#include "mof.h"
#include "types.h"
#include "mofyacc.h"
#include "buffer.h"
#include "ptrarray.h"
#include "state.h"
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

extern int yyparse();
int closeIncludeFile();

struct _MOF_Parser
{
    MOF_State state;
};

typedef struct _StackItem
{
    char* file;
    unsigned int line;
    YY_BUFFER_STATE buffer;
}
StackItem;

/* Stack of parser states for open nested MOF files */
static StackItem s_stack[MOF_STACK_SIZE];

/* Current size of stack s_stack[s_top-1] is the top */
static size_t s_top = 0;

/*
**==============================================================================
**
** Case-insensitive keywords (see CIM Infrastructure specification).
**
**==============================================================================
*/
/* True and false */
/* Null value */
/* Data types */
/* Ref */
/* Scope */
/* Flavor */
/* Instance of */
/* Object */
/* Alias */
/* #pragma */
/*
**==============================================================================
**
** Literal productions (see CIM Infrastructure specification).
**
**==============================================================================
*/
/*
**------------------------------------------------------------------------------
**
** Lex productions:
**
**------------------------------------------------------------------------------
*/
#line 657 "lex.yy.c"

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap YY_PROTO(( void ));
#else
extern int yywrap YY_PROTO(( void ));
#endif
#endif

#ifndef YY_NO_UNPUT
static void yyunput YY_PROTO(( int c, char *buf_ptr ));
#endif

#ifndef yytext_ptr
static void yy_flex_strncpy YY_PROTO(( char *, yyconst char *, int ));
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen YY_PROTO(( yyconst char * ));
#endif

#ifndef YY_NO_INPUT
#ifdef __cplusplus
static int yyinput YY_PROTO(( void ));
#else
static int input YY_PROTO(( void ));
#endif
#endif

#if YY_STACK_USED
static int yy_start_stack_ptr = 0;
static int yy_start_stack_depth = 0;
static int *yy_start_stack = 0;
#ifndef YY_NO_PUSH_STATE
static void yy_push_state YY_PROTO(( int new_state ));
#endif
#ifndef YY_NO_POP_STATE
static void yy_pop_state YY_PROTO(( void ));
#endif
#ifndef YY_NO_TOP_STATE
static int yy_top_state YY_PROTO(( void ));
#endif

#else
#define YY_NO_PUSH_STATE 1
#define YY_NO_POP_STATE 1
#define YY_NO_TOP_STATE 1
#endif

#ifdef YY_MALLOC_DECL
YY_MALLOC_DECL
#else
#if __STDC__
#ifndef __cplusplus
#include <stdlib.h>
#endif
#else
/* Just try to get by without declaring the routines.  This will fail
 * miserably on non-ANSI systems for which sizeof(size_t) != sizeof(int)
 * or sizeof(void*) != sizeof(int).
 */
#endif
#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#define YY_READ_BUF_SIZE 8192
#endif

/* Copy whatever the last rule matched to the standard output. */

#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO (void) fwrite( yytext, yyleng, 1, yyout )
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
        if ( yy_current_buffer->yy_is_interactive ) \
                { \
                int c = '*', n; \
                for ( n = 0; n < max_size && \
                             (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
                        buf[n] = (char) c; \
                if ( c == '\n' ) \
                        buf[n++] = (char) c; \
                if ( c == EOF && ferror( yyin ) ) \
                        YY_FATAL_ERROR( "input in flex scanner failed" ); \
                result = n; \
                } \
        else if ( ((result = fread( buf, 1, max_size, yyin )) == 0) \
                  && ferror( yyin ) ) \
                YY_FATAL_ERROR( "input in flex scanner failed" );
#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL int yylex YY_PROTO(( void ))
#endif

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

#define YY_RULE_SETUP \
        YY_USER_ACTION

YY_DECL
        {
        register yy_state_type yy_current_state;
        register char *yy_cp, *yy_bp;
        register int yy_act;

#line 150 "mof.l"


#line 811 "lex.yy.c"

        if ( yy_init )
                {
                yy_init = 0;

#ifdef YY_USER_INIT
                YY_USER_INIT;
#endif

                if ( ! yy_start )
                        yy_start = 1;   /* first start state */

                if ( ! yyin )
                        yyin = stdin;

                if ( ! yyout )
                        yyout = stdout;

                if ( ! yy_current_buffer )
                        yy_current_buffer =
                                yy_create_buffer( yyin, YY_BUF_SIZE );

                yy_load_buffer_state();
                }

        while ( 1 )             /* loops until end-of-file is reached */
                {
                yy_cp = yy_c_buf_p;

                /* Support of yytext. */
                *yy_cp = yy_hold_char;

                /* yy_bp points to the position in yy_ch_buf of the start of
                 * the current run.
                 */
                yy_bp = yy_cp;

                yy_current_state = yy_start;
yy_match:
                do
                        {
                        register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];
                        if ( yy_accept[yy_current_state] )
                                {
                                yy_last_accepting_state = yy_current_state;
                                yy_last_accepting_cpos = yy_cp;
                                }
                        while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
                                {
                                yy_current_state = (int) yy_def[yy_current_state];
                                if ( yy_current_state >= 286 )
                                        yy_c = yy_meta[(unsigned int) yy_c];
                                }
                        yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
                        ++yy_cp;
                        }
                while ( yy_base[yy_current_state] != 461 );

yy_find_action:
                yy_act = yy_accept[yy_current_state];
                if ( yy_act == 0 )
                        { /* have to back up */
                        yy_cp = yy_last_accepting_cpos;
                        yy_current_state = yy_last_accepting_state;
                        yy_act = yy_accept[yy_current_state];
                        }

                YY_DO_BEFORE_ACTION;


do_action:      /* This label is used only to access EOF actions. */


                switch ( yy_act )
        { /* beginning of action switch */
                        case 0: /* must back up */
                        /* undo the effects of YY_DO_BEFORE_ACTION */
                        *yy_cp = yy_hold_char;
                        yy_cp = yy_last_accepting_cpos;
                        yy_current_state = yy_last_accepting_state;
                        goto yy_find_action;

case YY_STATE_EOF(INITIAL):
#line 152 "mof.l"
{
    if (s_top == 0)
        yyterminate();
    else
    {
        if (closeIncludeFile() != 0)
            return TOK_ERROR;
    }
}
        YY_BREAK
case 1:
YY_RULE_SETUP
#line 162 "mof.l"
{
    yylval.boolean = 1;
    return TOK_BOOLEAN_VALUE; 
}
        YY_BREAK
case 2:
YY_RULE_SETUP
#line 167 "mof.l"
{
    yylval.boolean = 0;
    return TOK_BOOLEAN_VALUE; 
}
        YY_BREAK
case 3:
YY_RULE_SETUP
#line 172 "mof.l"
{
    return TOK_NULL; 
}
        YY_BREAK
case 4:
YY_RULE_SETUP
#line 176 "mof.l"
{
    yylval.identifier = MOF_Strdup(&state.heap, yytext);
    return TOK_BOOLEAN; 
}
        YY_BREAK
case 5:
YY_RULE_SETUP
#line 181 "mof.l"
{
    return TOK_SINT8; 
}
        YY_BREAK
case 6:
YY_RULE_SETUP
#line 185 "mof.l"
{
    return TOK_UINT8; 
}
        YY_BREAK
case 7:
YY_RULE_SETUP
#line 189 "mof.l"
{
    return TOK_SINT16; 
}
        YY_BREAK
case 8:
YY_RULE_SETUP
#line 193 "mof.l"
{
    return TOK_UINT16; 
}
        YY_BREAK
case 9:
YY_RULE_SETUP
#line 197 "mof.l"
{
    return TOK_SINT32; 
}
        YY_BREAK
case 10:
YY_RULE_SETUP
#line 201 "mof.l"
{
    return TOK_UINT32; 
}
        YY_BREAK
case 11:
YY_RULE_SETUP
#line 205 "mof.l"
{
    return TOK_SINT64; 
}
        YY_BREAK
case 12:
YY_RULE_SETUP
#line 209 "mof.l"
{
    return TOK_UINT64; 
}
        YY_BREAK
case 13:
YY_RULE_SETUP
#line 213 "mof.l"
{
    return TOK_REAL32; 
}
        YY_BREAK
case 14:
YY_RULE_SETUP
#line 217 "mof.l"
{
    return TOK_REAL64; 
}
        YY_BREAK
case 15:
YY_RULE_SETUP
#line 221 "mof.l"
{
    yylval.identifier = MOF_Strdup(&state.heap, yytext);
    return TOK_DATETIME; 
}
        YY_BREAK
case 16:
YY_RULE_SETUP
#line 226 "mof.l"
{
    return TOK_CHAR16; 
}
        YY_BREAK
case 17:
YY_RULE_SETUP
#line 230 "mof.l"
{
    yylval.identifier = MOF_Strdup(&state.heap, yytext);
    return TOK_STRING; 
}
        YY_BREAK
case 18:
YY_RULE_SETUP
#line 235 "mof.l"
{
    return TOK_REF; 
}
        YY_BREAK
case 19:
YY_RULE_SETUP
#line 239 "mof.l"
{
    return TOK_SCOPE; 
}
        YY_BREAK
case 20:
YY_RULE_SETUP
#line 243 "mof.l"
{
    yylval.identifier = MOF_Strdup(&state.heap, yytext);
    return TOK_CLASS; 
}
        YY_BREAK
case 21:
YY_RULE_SETUP
#line 248 "mof.l"
{
    yylval.identifier = MOF_Strdup(&state.heap, yytext);
    return TOK_ASSOCIATION; 
}
        YY_BREAK
case 22:
YY_RULE_SETUP
#line 253 "mof.l"
{
    yylval.identifier = MOF_Strdup(&state.heap, yytext);
    return TOK_INDICATION; 
}
        YY_BREAK
case 23:
YY_RULE_SETUP
#line 258 "mof.l"
{
    yylval.identifier = MOF_Strdup(&state.heap, yytext);
    return TOK_QUALIFIER; 
}
        YY_BREAK
case 24:
YY_RULE_SETUP
#line 263 "mof.l"
{
    yylval.identifier = MOF_Strdup(&state.heap, yytext);
    return TOK_PROPERTY; 
}
        YY_BREAK
case 25:
YY_RULE_SETUP
#line 268 "mof.l"
{
    yylval.identifier = MOF_Strdup(&state.heap, yytext);
    return TOK_REFERENCE; 
}
        YY_BREAK
case 26:
YY_RULE_SETUP
#line 273 "mof.l"
{
    yylval.identifier = MOF_Strdup(&state.heap, yytext);
    return TOK_METHOD; 
}
        YY_BREAK
case 27:
YY_RULE_SETUP
#line 278 "mof.l"
{
    yylval.identifier = MOF_Strdup(&state.heap, yytext);
    return TOK_PARAMETER; 
}
        YY_BREAK
case 28:
YY_RULE_SETUP
#line 283 "mof.l"
{
    yylval.identifier = MOF_Strdup(&state.heap, yytext);
    return TOK_ANY;
}
        YY_BREAK
case 29:
YY_RULE_SETUP
#line 288 "mof.l"
{
    yylval.identifier = MOF_Strdup(&state.heap, yytext);
    return TOK_FLAVOR;
}
        YY_BREAK
case 30:
YY_RULE_SETUP
#line 293 "mof.l"
{
    yylval.identifier = MOF_Strdup(&state.heap, yytext);
    return TOK_ENABLEOVERRIDE;
}
        YY_BREAK
case 31:
YY_RULE_SETUP
#line 298 "mof.l"
{
    yylval.identifier = MOF_Strdup(&state.heap, yytext);
    return TOK_DISABLEOVERRIDE;
}
        YY_BREAK
case 32:
YY_RULE_SETUP
#line 303 "mof.l"
{
    yylval.identifier = MOF_Strdup(&state.heap, yytext);
    return TOK_RESTRICTED;
}
        YY_BREAK
case 33:
YY_RULE_SETUP
#line 308 "mof.l"
{
    yylval.identifier = MOF_Strdup(&state.heap, yytext);
    return TOK_TOSUBCLASS;
}
        YY_BREAK
case 34:
YY_RULE_SETUP
#line 313 "mof.l"
{
    yylval.identifier = MOF_Strdup(&state.heap, yytext);
    return TOK_TOINSTANCE;
}
        YY_BREAK
case 35:
YY_RULE_SETUP
#line 318 "mof.l"
{
    yylval.identifier = MOF_Strdup(&state.heap, yytext);
    return TOK_TRANSLATABLE;
}
        YY_BREAK
case 36:
YY_RULE_SETUP
#line 323 "mof.l"
{
    return TOK_INSTANCE;
}
        YY_BREAK
case 37:
YY_RULE_SETUP
#line 327 "mof.l"
{
    yylval.identifier = MOF_Strdup(&state.heap, yytext);
    return TOK_OF;
}
        YY_BREAK
case 38:
YY_RULE_SETUP
#line 332 "mof.l"
{
    return TOK_AS;
}
        YY_BREAK
case 39:
YY_RULE_SETUP
#line 336 "mof.l"
{
    return TOK_OBJECT;
}
        YY_BREAK
case 40:
YY_RULE_SETUP
#line 340 "mof.l"
{
    yylval.identifier = MOF_Strdup(&state.heap, yytext);
    return TOK_PRAGMA;
}
        YY_BREAK
case 41:
YY_RULE_SETUP
#line 345 "mof.l"
{
    /* C-sytle comments */
    int c;
    int prev;

    /* Discard C-style comments. Replace with a single space since
     * comments may function as token separators.
     */

    for (c = input(), prev = '\0'; EOF != c; prev = c, c = input())
    {
        /* Check for closing comment */
        if (prev == '*' && c == '/')
            break;

        /* Increment line counter on newlines */
        if (c == '\n')
            state.line++;
    }

    /* Inject a blank character into input */
    unput(' ');
}
        YY_BREAK
case 42:
YY_RULE_SETUP
#line 369 "mof.l"
{
    /* C++-style comments */
    int c;

    /* Discard all characters on this comment line including the newline */

    for (c = input(); EOF != c; c = input())
    {
        /* Increment line counter on newlines */
        if (c == '\n')
        {
            state.line++;
            break;
        }
    }
}
        YY_BREAK
case 43:
YY_RULE_SETUP
#line 386 "mof.l"
{
    /* Read a string literal */
    int c;
    Buffer buf = BUFFER_INITIALIZER;

    /* Scan until the closing quote is found */
    for (;;)
    {
        c = input();

        if (EOF == c || c == '"')
            break;

        if (Buffer_AppendChar(&buf, (char)c) != 0)
        {
            yyerrorf(ID_OUT_OF_MEMORY, "out of memory");
            return TOK_ERROR;
        }

        /* If backslash, get next character */
        if (c == '\\')
        {
            c = input();

            if (EOF == c)
            {
                yyerrorf(ID_UNTERMINATED_STRING_LITERAL, 
                    "unterminated string literal");
                return TOK_ERROR;
            }

            if (Buffer_AppendChar(&buf, (char)c) != 0)
            {
                yyerrorf(ID_OUT_OF_MEMORY, "out of memory");
                return TOK_ERROR;
            }
        }
    }

    /* Append zero-terminator */
    if (Buffer_AppendChar(&buf, '\0') != 0)
    {
        yyerrorf(ID_OUT_OF_MEMORY, "out of memory");
        return TOK_ERROR;
    }

    /* Return the string */
    yylval.string = buf.data;
    return TOK_STRING_VALUE;
}
        YY_BREAK
case 44:
YY_RULE_SETUP
#line 437 "mof.l"
{
    yylval.character = yytext[1];
    return TOK_CHAR_VALUE;
}
        YY_BREAK
case 45:
YY_RULE_SETUP
#line 442 "mof.l"
{

    switch (yytext[2])
    {
        case 'r':
            yylval.character = '\r';
            break;
        case 'n':
            yylval.character = '\n';
            break;
        case 't':
            yylval.character = '\t';
            break;
        case 'f':
            yylval.character = '\f';
            break;
        case 'b':
            yylval.character = '\b';
            break;
        case '\"':
            yylval.character = '"';
            break;
        case '\'':
            yylval.character = '\'';
            break;
        case '\\':
            yylval.character = '\\';
            break;
        default:
            yyerrorf(ID_INTERNAL_ERROR, "internal error");
            return TOK_ERROR;
    }

    return TOK_CHAR_VALUE;
}
        YY_BREAK
case 46:
YY_RULE_SETUP
#line 478 "mof.l"
{
    char* end;

    if (yyleng - 4 > 4)
    {
        yyerrorf(ID_ILLEGAL_HEX_CHARACTER, "illegal hex character");
        return TOK_ERROR;
    }

    yylval.character = (MI_Char16)strtoul(&yytext[3], &end, 16);

    if (*end != '\'')
    {
        yyerrorf(ID_ILLEGAL_HEX_CHARACTER, "illegal hex character");
        return TOK_ERROR;
    }

    return TOK_CHAR_VALUE;
}
        YY_BREAK
case 47:
YY_RULE_SETUP
#line 498 "mof.l"
{
    yylval.integer = 0;
    return TOK_INTEGER_VALUE;
}
        YY_BREAK
case 48:
YY_RULE_SETUP
#line 503 "mof.l"
{
    errno = 0;
    if (yytext[0] == '-')
        yylval.integer = (MI_Sint64)Strtoll(yytext, NULL, 10);
    else
        yylval.integer = (MI_Sint64)Strtoull(yytext, NULL, 10);
    
    if (errno == ERANGE)
    {
        yyerrorf(ID_INTEGER_OVERFLOW, "integer overflow");
        return TOK_ERROR;
    }
    return TOK_INTEGER_VALUE;
}
        YY_BREAK
case 49:
YY_RULE_SETUP
#line 518 "mof.l"
{
    yylval.real = (double)strtod(yytext, NULL);
    return TOK_REAL_VALUE;
}
        YY_BREAK
case 50:
YY_RULE_SETUP
#line 523 "mof.l"
{
    errno = 0;
    if (yytext[0] == '-')
        yylval.integer = (MI_Sint64)Strtoll(yytext, NULL, 16);
    else
        yylval.integer = (MI_Sint64)Strtoull(yytext, NULL, 16);
    
    if (errno == ERANGE)
    {
        yyerrorf(ID_INTEGER_OVERFLOW, "integer overflow");
        return TOK_ERROR;
    }
    return TOK_INTEGER_VALUE;
}
        YY_BREAK
case 51:
YY_RULE_SETUP
#line 538 "mof.l"
{
    errno = 0;
    if (yytext[0] == '-')
        yylval.integer = (MI_Sint64)Strtoll(yytext, NULL, 8);
    else
        yylval.integer = (MI_Sint64)Strtoull(yytext, NULL, 8);
    
    if (errno == ERANGE)
    {
        yyerrorf(ID_INTEGER_OVERFLOW, "integer overflow");
        return TOK_ERROR;
    }
    return TOK_INTEGER_VALUE;
}
        YY_BREAK
case 52:
YY_RULE_SETUP
#line 553 "mof.l"
{
    char* end;

    if (yytext[0] == '-')
        yylval.integer = (MI_Sint64)Strtoll(yytext, &end, 2);
    else
        yylval.integer = (MI_Sint64)Strtoull(yytext, &end, 2);

    if (*end != 'B' && *end != 'b')
    {
        yyerrorf(ID_ILLEGAL_BINARY_LITERAL, "illegal binary literal");
        return TOK_ERROR;
    }
    if (errno == ERANGE)
    {
        yyerrorf(ID_INTEGER_OVERFLOW, "integer overflow");
        return TOK_ERROR;
    }

    return TOK_INTEGER_VALUE;
}
        YY_BREAK
case 53:
YY_RULE_SETUP
#line 575 "mof.l"
{
    yylval.identifier = MOF_Strdup(&state.heap, yytext);
    return TOK_IDENT;
}
        YY_BREAK
case 54:
YY_RULE_SETUP
#line 580 "mof.l"
{
    yylval.identifier = MOF_Strdup(&state.heap, yytext);
    return TOK_ALIAS_IDENTIFIER;
}
        YY_BREAK
case 55:
YY_RULE_SETUP
#line 585 "mof.l"
{
    return '=';
}
        YY_BREAK
case 56:
YY_RULE_SETUP
#line 589 "mof.l"
{
    return '(';
}
        YY_BREAK
case 57:
YY_RULE_SETUP
#line 593 "mof.l"
{
    return ')';
}
        YY_BREAK
case 58:
YY_RULE_SETUP
#line 597 "mof.l"
{
    return '[';
}
        YY_BREAK
case 59:
YY_RULE_SETUP
#line 601 "mof.l"
{
    return ']';
}
        YY_BREAK
case 60:
YY_RULE_SETUP
#line 605 "mof.l"
{
    return '{';
}
        YY_BREAK
case 61:
YY_RULE_SETUP
#line 609 "mof.l"
{
    return '}';
}
        YY_BREAK
case 62:
YY_RULE_SETUP
#line 613 "mof.l"
{
    return ':';
}
        YY_BREAK
case 63:
YY_RULE_SETUP
#line 617 "mof.l"
{
   return ';';
}
        YY_BREAK
case 64:
YY_RULE_SETUP
#line 621 "mof.l"
{
    return ',';
}
        YY_BREAK
case 65:
YY_RULE_SETUP
#line 625 "mof.l"
{
    /* swallow whiteSpaceChar */
    int i;

    for (i = 0; i < yyleng; i++)
    {
        if (yytext[i] == '\n')
            state.line++;
    }
}
        YY_BREAK
case 66:
YY_RULE_SETUP
#line 636 "mof.l"
{
    yyterminate();
}
        YY_BREAK
case 67:
YY_RULE_SETUP
#line 640 "mof.l"
ECHO;
        YY_BREAK
#line 1587 "lex.yy.c"

        case YY_END_OF_BUFFER:
                {
                /* Amount of text matched not including the EOB char. */
                int yy_amount_of_matched_text = (int) (yy_cp - yytext_ptr) - 1;

                /* Undo the effects of YY_DO_BEFORE_ACTION. */
                *yy_cp = yy_hold_char;
                YY_RESTORE_YY_MORE_OFFSET

                if ( yy_current_buffer->yy_buffer_status == YY_BUFFER_NEW )
                        {
                        /* We're scanning a new file or input source.  It's
                         * possible that this happened because the user
                         * just pointed yyin at a new source and called
                         * yylex().  If so, then we have to assure
                         * consistency between yy_current_buffer and our
                         * globals.  Here is the right place to do so, because
                         * this is the first action (other than possibly a
                         * back-up) that will match for the new input source.
                         */
                        yy_n_chars = yy_current_buffer->yy_n_chars;
                        yy_current_buffer->yy_input_file = yyin;
                        yy_current_buffer->yy_buffer_status = YY_BUFFER_NORMAL;
                        }

                /* Note that here we test for yy_c_buf_p "<=" to the position
                 * of the first EOB in the buffer, since yy_c_buf_p will
                 * already have been incremented past the NUL character
                 * (since all states make transitions on EOB to the
                 * end-of-buffer state).  Contrast this with the test
                 * in input().
                 */
                if ( yy_c_buf_p <= &yy_current_buffer->yy_ch_buf[yy_n_chars] )
                        { /* This was really a NUL. */
                        yy_state_type yy_next_state;

                        yy_c_buf_p = yytext_ptr + yy_amount_of_matched_text;

                        yy_current_state = yy_get_previous_state();

                        /* Okay, we're now positioned to make the NUL
                         * transition.  We couldn't have
                         * yy_get_previous_state() go ahead and do it
                         * for us because it doesn't know how to deal
                         * with the possibility of jamming (and we don't
                         * want to build jamming into it because then it
                         * will run more slowly).
                         */

                        yy_next_state = yy_try_NUL_trans( yy_current_state );

                        yy_bp = yytext_ptr + YY_MORE_ADJ;

                        if ( yy_next_state )
                                {
                                /* Consume the NUL. */
                                yy_cp = ++yy_c_buf_p;
                                yy_current_state = yy_next_state;
                                goto yy_match;
                                }

                        else
                                {
                                yy_cp = yy_c_buf_p;
                                goto yy_find_action;
                                }
                        }

                else switch ( yy_get_next_buffer() )
                        {
                        case EOB_ACT_END_OF_FILE:
                                {
                                yy_did_buffer_switch_on_eof = 0;

                                if ( yywrap() )
                                        {
                                        /* Note: because we've taken care in
                                         * yy_get_next_buffer() to have set up
                                         * yytext, we can now set up
                                         * yy_c_buf_p so that if some total
                                         * hoser (like flex itself) wants to
                                         * call the scanner after we return the
                                         * YY_NULL, it'll still work - another
                                         * YY_NULL will get returned.
                                         */
                                        yy_c_buf_p = yytext_ptr + YY_MORE_ADJ;

                                        yy_act = YY_STATE_EOF(YY_START);
                                        goto do_action;
                                        }

                                else
                                        {
                                        if ( ! yy_did_buffer_switch_on_eof )
                                                YY_NEW_FILE;
                                        }
                                break;
                                }

                        case EOB_ACT_CONTINUE_SCAN:
                                yy_c_buf_p =
                                        yytext_ptr + yy_amount_of_matched_text;

                                yy_current_state = yy_get_previous_state();

                                yy_cp = yy_c_buf_p;
                                yy_bp = yytext_ptr + YY_MORE_ADJ;
                                goto yy_match;

                        case EOB_ACT_LAST_MATCH:
                                yy_c_buf_p =
                                &yy_current_buffer->yy_ch_buf[yy_n_chars];

                                yy_current_state = yy_get_previous_state();

                                yy_cp = yy_c_buf_p;
                                yy_bp = yytext_ptr + YY_MORE_ADJ;
                                goto yy_find_action;
                        }
                break;
                }

        default:
                YY_FATAL_ERROR(
                        "fatal flex scanner internal error--no action found" );
        } /* end of action switch */
                } /* end of scanning one token */
        } /* end of yylex */


/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *      EOB_ACT_LAST_MATCH -
 *      EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *      EOB_ACT_END_OF_FILE - end of file
 */

static int yy_get_next_buffer()
        {
        register char *dest = yy_current_buffer->yy_ch_buf;
        register char *source = yytext_ptr;
        register int number_to_move, i;
        int ret_val;

        if ( yy_c_buf_p > &yy_current_buffer->yy_ch_buf[yy_n_chars + 1] )
                YY_FATAL_ERROR(
                "fatal flex scanner internal error--end of buffer missed" );

        if ( yy_current_buffer->yy_fill_buffer == 0 )
                { /* Don't try to fill the buffer, so this is an EOF. */
                if ( yy_c_buf_p - yytext_ptr - YY_MORE_ADJ == 1 )
                        {
                        /* We matched a single character, the EOB, so
                         * treat this as a final EOF.
                         */
                        return EOB_ACT_END_OF_FILE;
                        }

                else
                        {
                        /* We matched some text prior to the EOB, first
                         * process it.
                         */
                        return EOB_ACT_LAST_MATCH;
                        }
                }

        /* Try to read more data. */

        /* First move last chars to start of buffer. */
        number_to_move = (int) (yy_c_buf_p - yytext_ptr) - 1;

        for ( i = 0; i < number_to_move; ++i )
                *(dest++) = *(source++);

        if ( yy_current_buffer->yy_buffer_status == YY_BUFFER_EOF_PENDING )
                /* don't do the read, it's not guaranteed to return an EOF,
                 * just force an EOF
                 */
                yy_current_buffer->yy_n_chars = yy_n_chars = 0;

        else
                {
                int num_to_read =
                        yy_current_buffer->yy_buf_size - number_to_move - 1;

                while ( num_to_read <= 0 )
                        { /* Not enough room in the buffer - grow it. */
#ifdef YY_USES_REJECT
                        YY_FATAL_ERROR(
"input buffer overflow, can't enlarge buffer because scanner uses REJECT" );
#else

                        /* just a shorter name for the current buffer */
                        YY_BUFFER_STATE b = yy_current_buffer;

                        int yy_c_buf_p_offset =
                                (int) (yy_c_buf_p - b->yy_ch_buf);

                        if ( b->yy_is_our_buffer )
                                {
                                int new_size = b->yy_buf_size * 2;

                                if ( new_size <= 0 )
                                        b->yy_buf_size += b->yy_buf_size / 8;
                                else
                                        b->yy_buf_size *= 2;

                                b->yy_ch_buf = (char *)
                                        /* Include room in for 2 EOB chars. */
                                        yy_flex_realloc( (void *) b->yy_ch_buf,
                                                         b->yy_buf_size + 2 );
                                }
                        else
                                /* Can't grow it, we don't own it. */
                                b->yy_ch_buf = 0;

                        if ( ! b->yy_ch_buf )
                                YY_FATAL_ERROR(
                                "fatal error - scanner input buffer overflow" );

                        yy_c_buf_p = &b->yy_ch_buf[yy_c_buf_p_offset];

                        num_to_read = yy_current_buffer->yy_buf_size -
                                                number_to_move - 1;
#endif
                        }

                if ( num_to_read > YY_READ_BUF_SIZE )
                        num_to_read = YY_READ_BUF_SIZE;

                /* Read in more data. */
                YY_INPUT( (&yy_current_buffer->yy_ch_buf[number_to_move]),
                        yy_n_chars, num_to_read );

                yy_current_buffer->yy_n_chars = yy_n_chars;
                }

        if ( yy_n_chars == 0 )
                {
                if ( number_to_move == YY_MORE_ADJ )
                        {
                        ret_val = EOB_ACT_END_OF_FILE;
                        yyrestart( yyin );
                        }

                else
                        {
                        ret_val = EOB_ACT_LAST_MATCH;
                        yy_current_buffer->yy_buffer_status =
                                YY_BUFFER_EOF_PENDING;
                        }
                }

        else
                ret_val = EOB_ACT_CONTINUE_SCAN;

        yy_n_chars += number_to_move;
        yy_current_buffer->yy_ch_buf[yy_n_chars] = YY_END_OF_BUFFER_CHAR;
        yy_current_buffer->yy_ch_buf[yy_n_chars + 1] = YY_END_OF_BUFFER_CHAR;

        yytext_ptr = &yy_current_buffer->yy_ch_buf[0];

        return ret_val;
        }


/* yy_get_previous_state - get the state just before the EOB char was reached */

static yy_state_type yy_get_previous_state()
        {
        register yy_state_type yy_current_state;
        register char *yy_cp;

        yy_current_state = yy_start;

        for ( yy_cp = yytext_ptr + YY_MORE_ADJ; yy_cp < yy_c_buf_p; ++yy_cp )
                {
                register YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
                if ( yy_accept[yy_current_state] )
                        {
                        yy_last_accepting_state = yy_current_state;
                        yy_last_accepting_cpos = yy_cp;
                        }
                while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
                        {
                        yy_current_state = (int) yy_def[yy_current_state];
                        if ( yy_current_state >= 286 )
                                yy_c = yy_meta[(unsigned int) yy_c];
                        }
                yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
                }

        return yy_current_state;
        }


/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *      next_state = yy_try_NUL_trans( current_state );
 */

#ifdef YY_USE_PROTOS
static yy_state_type yy_try_NUL_trans( yy_state_type yy_current_state )
#else
static yy_state_type yy_try_NUL_trans( yy_current_state )
yy_state_type yy_current_state;
#endif
        {
        register int yy_is_jam;
        register char *yy_cp = yy_c_buf_p;

        register YY_CHAR yy_c = 1;
        if ( yy_accept[yy_current_state] )
                {
                yy_last_accepting_state = yy_current_state;
                yy_last_accepting_cpos = yy_cp;
                }
        while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
                {
                yy_current_state = (int) yy_def[yy_current_state];
                if ( yy_current_state >= 286 )
                        yy_c = yy_meta[(unsigned int) yy_c];
                }
        yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
        yy_is_jam = (yy_current_state == 285);

        return yy_is_jam ? 0 : yy_current_state;
        }


#ifndef YY_NO_UNPUT
#ifdef YY_USE_PROTOS
static void yyunput( int c, register char *yy_bp )
#else
static void yyunput( c, yy_bp )
int c;
register char *yy_bp;
#endif
        {
        register char *yy_cp = yy_c_buf_p;

        /* undo effects of setting up yytext */
        *yy_cp = yy_hold_char;

        if ( yy_cp < yy_current_buffer->yy_ch_buf + 2 )
                { /* need to shift things up to make room */
                /* +2 for EOB chars. */
                register int number_to_move = yy_n_chars + 2;
                register char *dest = &yy_current_buffer->yy_ch_buf[
                                        yy_current_buffer->yy_buf_size + 2];
                register char *source =
                                &yy_current_buffer->yy_ch_buf[number_to_move];

                while ( source > yy_current_buffer->yy_ch_buf )
                        *--dest = *--source;

                yy_cp += (int) (dest - source);
                yy_bp += (int) (dest - source);
                yy_current_buffer->yy_n_chars =
                        yy_n_chars = yy_current_buffer->yy_buf_size;

                if ( yy_cp < yy_current_buffer->yy_ch_buf + 2 )
                        YY_FATAL_ERROR( "flex scanner push-back overflow" );
                }

        *--yy_cp = (char) c;


        yytext_ptr = yy_bp;
        yy_hold_char = *yy_cp;
        yy_c_buf_p = yy_cp;
        }
#endif  /* ifndef YY_NO_UNPUT */


#ifdef __cplusplus
static int yyinput()
#else
static int input()
#endif
        {
        int c;

        *yy_c_buf_p = yy_hold_char;

        if ( *yy_c_buf_p == YY_END_OF_BUFFER_CHAR )
                {
                /* yy_c_buf_p now points to the character we want to return.
                 * If this occurs *before* the EOB characters, then it's a
                 * valid NUL; if not, then we've hit the end of the buffer.
                 */
                if ( yy_c_buf_p < &yy_current_buffer->yy_ch_buf[yy_n_chars] )
                        /* This was really a NUL. */
                        *yy_c_buf_p = '\0';

                else
                        { /* need more input */
                        int offset = yy_c_buf_p - yytext_ptr;
                        ++yy_c_buf_p;

                        switch ( yy_get_next_buffer() )
                                {
                                case EOB_ACT_LAST_MATCH:
                                        /* This happens because yy_g_n_b()
                                         * sees that we've accumulated a
                                         * token and flags that we need to
                                         * try matching the token before
                                         * proceeding.  But for input(),
                                         * there's no matching to consider.
                                         * So convert the EOB_ACT_LAST_MATCH
                                         * to EOB_ACT_END_OF_FILE.
                                         */

                                        /* Reset buffer status. */
                                        yyrestart( yyin );

                                        /* fall through */

                                case EOB_ACT_END_OF_FILE:
                                        {
                                        if ( yywrap() )
                                                return EOF;

                                        if ( ! yy_did_buffer_switch_on_eof )
                                                YY_NEW_FILE;
#ifdef __cplusplus
                                        return yyinput();
#else
                                        return input();
#endif
                                        }

                                case EOB_ACT_CONTINUE_SCAN:
                                        yy_c_buf_p = yytext_ptr + offset;
                                        break;
                                }
                        }
                }

        c = *(unsigned char *) yy_c_buf_p;      /* cast for 8-bit char's */
        *yy_c_buf_p = '\0';     /* preserve yytext */
        yy_hold_char = *++yy_c_buf_p;


        return c;
        }


#ifdef YY_USE_PROTOS
void yyrestart( FILE *input_file )
#else
void yyrestart( input_file )
FILE *input_file;
#endif
        {
        if ( ! yy_current_buffer )
                yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE );

        yy_init_buffer( yy_current_buffer, input_file );
        yy_load_buffer_state();
        }


#ifdef YY_USE_PROTOS
void yy_switch_to_buffer( YY_BUFFER_STATE new_buffer )
#else
void yy_switch_to_buffer( new_buffer )
YY_BUFFER_STATE new_buffer;
#endif
        {
        if ( yy_current_buffer == new_buffer )
                return;

        if ( yy_current_buffer )
                {
                /* Flush out information for old buffer. */
                *yy_c_buf_p = yy_hold_char;
                yy_current_buffer->yy_buf_pos = yy_c_buf_p;
                yy_current_buffer->yy_n_chars = yy_n_chars;
                }

        yy_current_buffer = new_buffer;
        yy_load_buffer_state();

        /* We don't actually know whether we did this switch during
         * EOF (yywrap()) processing, but the only time this flag
         * is looked at is after yywrap() is called, so it's safe
         * to go ahead and always set it.
         */
        yy_did_buffer_switch_on_eof = 1;
        }


#ifdef YY_USE_PROTOS
void yy_load_buffer_state( void )
#else
void yy_load_buffer_state()
#endif
        {
        yy_n_chars = yy_current_buffer->yy_n_chars;
        yytext_ptr = yy_c_buf_p = yy_current_buffer->yy_buf_pos;
        yyin = yy_current_buffer->yy_input_file;
        yy_hold_char = *yy_c_buf_p;
        }


#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_create_buffer( FILE *file, int size )
#else
YY_BUFFER_STATE yy_create_buffer( file, size )
FILE *file;
int size;
#endif
        {
        YY_BUFFER_STATE b;

        b = (YY_BUFFER_STATE) yy_flex_alloc( sizeof( struct yy_buffer_state ) );
        if ( ! b )
                YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

        b->yy_buf_size = size;

        /* yy_ch_buf has to be 2 characters longer than the size given because
         * we need to put in 2 end-of-buffer characters.
         */
        b->yy_ch_buf = (char *) yy_flex_alloc( b->yy_buf_size + 2 );
        if ( ! b->yy_ch_buf )
                YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

        b->yy_is_our_buffer = 1;

        yy_init_buffer( b, file );

        return b;
        }


#ifdef YY_USE_PROTOS
void yy_delete_buffer( YY_BUFFER_STATE b )
#else
void yy_delete_buffer( b )
YY_BUFFER_STATE b;
#endif
        {
        if ( ! b )
                return;

        if ( b == yy_current_buffer )
                yy_current_buffer = (YY_BUFFER_STATE) 0;

        if ( b->yy_is_our_buffer )
                yy_flex_free( (void *) b->yy_ch_buf );

        yy_flex_free( (void *) b );
        }


#ifndef YY_ALWAYS_INTERACTIVE
#ifndef YY_NEVER_INTERACTIVE
extern int isatty YY_PROTO(( int ));
#endif
#endif

#ifdef YY_USE_PROTOS
void yy_init_buffer( YY_BUFFER_STATE b, FILE *file )
#else
void yy_init_buffer( b, file )
YY_BUFFER_STATE b;
FILE *file;
#endif


        {
        yy_flush_buffer( b );

        b->yy_input_file = file;
        b->yy_fill_buffer = 1;

#if YY_ALWAYS_INTERACTIVE
        b->yy_is_interactive = 1;
#else
#if YY_NEVER_INTERACTIVE
        b->yy_is_interactive = 0;
#else
        b->yy_is_interactive = file ? (isatty( fileno(file) ) > 0) : 0;
#endif
#endif
        }


#ifdef YY_USE_PROTOS
void yy_flush_buffer( YY_BUFFER_STATE b )
#else
void yy_flush_buffer( b )
YY_BUFFER_STATE b;
#endif

        {
        if ( ! b )
                return;

        b->yy_n_chars = 0;

        /* We always need two end-of-buffer characters.  The first causes
         * a transition to the end-of-buffer state.  The second causes
         * a jam in that state.
         */
        b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
        b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

        b->yy_buf_pos = &b->yy_ch_buf[0];

        b->yy_at_bol = 1;
        b->yy_buffer_status = YY_BUFFER_NEW;

        if ( b == yy_current_buffer )
                yy_load_buffer_state();
        }


#ifndef YY_NO_SCAN_BUFFER
#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_scan_buffer( char *base, yy_size_t size )
#else
YY_BUFFER_STATE yy_scan_buffer( base, size )
char *base;
yy_size_t size;
#endif
        {
        YY_BUFFER_STATE b;

        if ( size < 2 ||
             base[size-2] != YY_END_OF_BUFFER_CHAR ||
             base[size-1] != YY_END_OF_BUFFER_CHAR )
                /* They forgot to leave room for the EOB's. */
                return 0;

        b = (YY_BUFFER_STATE) yy_flex_alloc( sizeof( struct yy_buffer_state ) );
        if ( ! b )
                YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );

        b->yy_buf_size = size - 2;      /* "- 2" to take care of EOB's */
        b->yy_buf_pos = b->yy_ch_buf = base;
        b->yy_is_our_buffer = 0;
        b->yy_input_file = 0;
        b->yy_n_chars = b->yy_buf_size;
        b->yy_is_interactive = 0;
        b->yy_at_bol = 1;
        b->yy_fill_buffer = 0;
        b->yy_buffer_status = YY_BUFFER_NEW;

        yy_switch_to_buffer( b );

        return b;
        }
#endif


#ifndef YY_NO_SCAN_STRING
#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_scan_string( yyconst char *yy_str )
#else
YY_BUFFER_STATE yy_scan_string( yy_str )
yyconst char *yy_str;
#endif
        {
        int len;
        for ( len = 0; yy_str[len]; ++len )
                ;

        return yy_scan_bytes( yy_str, len );
        }
#endif


#ifndef YY_NO_SCAN_BYTES
#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_scan_bytes( yyconst char *bytes, int len )
#else
YY_BUFFER_STATE yy_scan_bytes( bytes, len )
yyconst char *bytes;
int len;
#endif
        {
        YY_BUFFER_STATE b;
        char *buf;
        yy_size_t n;
        int i;

        /* Get memory for full buffer, including space for trailing EOB's. */
        n = len + 2;
        buf = (char *) yy_flex_alloc( n );
        if ( ! buf )
                YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );

        for ( i = 0; i < len; ++i )
                buf[i] = bytes[i];

        buf[len] = buf[len+1] = YY_END_OF_BUFFER_CHAR;

        b = yy_scan_buffer( buf, n );
        if ( ! b )
                YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );

        /* It's okay to grow etc. this buffer, and we should throw it
         * away when we're done.
         */
        b->yy_is_our_buffer = 1;

        return b;
        }
#endif


#ifndef YY_NO_PUSH_STATE
#ifdef YY_USE_PROTOS
static void yy_push_state( int new_state )
#else
static void yy_push_state( new_state )
int new_state;
#endif
        {
        if ( yy_start_stack_ptr >= yy_start_stack_depth )
                {
                yy_size_t new_size;

                yy_start_stack_depth += YY_START_STACK_INCR;
                new_size = yy_start_stack_depth * sizeof( int );

                if ( ! yy_start_stack )
                        yy_start_stack = (int *) yy_flex_alloc( new_size );

                else
                        yy_start_stack = (int *) yy_flex_realloc(
                                        (void *) yy_start_stack, new_size );

                if ( ! yy_start_stack )
                        YY_FATAL_ERROR(
                        "out of memory expanding start-condition stack" );
                }

        yy_start_stack[yy_start_stack_ptr++] = YY_START;

        BEGIN(new_state);
        }
#endif


#ifndef YY_NO_POP_STATE
static void yy_pop_state()
        {
        if ( --yy_start_stack_ptr < 0 )
                YY_FATAL_ERROR( "start-condition stack underflow" );

        BEGIN(yy_start_stack[yy_start_stack_ptr]);
        }
#endif


#ifndef YY_NO_TOP_STATE
static int yy_top_state()
        {
        return yy_start_stack[yy_start_stack_ptr - 1];
        }
#endif

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

#ifdef YY_USE_PROTOS
static void yy_fatal_error( yyconst char msg[] )
#else
static void yy_fatal_error( msg )
char msg[];
#endif
        {
        (void) fprintf( stderr, "%s\n", msg );
        exit( YY_EXIT_FAILURE );
        }



/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
        do \
                { \
                /* Undo effects of setting up yytext. */ \
                yytext[yyleng] = yy_hold_char; \
                yy_c_buf_p = yytext + n; \
                yy_hold_char = *yy_c_buf_p; \
                *yy_c_buf_p = '\0'; \
                yyleng = n; \
                } \
        while ( 0 )


/* Internal utility routines. */

#ifndef yytext_ptr
#ifdef YY_USE_PROTOS
static void yy_flex_strncpy( char *s1, yyconst char *s2, int n )
#else
static void yy_flex_strncpy( s1, s2, n )
char *s1;
yyconst char *s2;
int n;
#endif
        {
        register int i;
        for ( i = 0; i < n; ++i )
                s1[i] = s2[i];
        }
#endif

#ifdef YY_NEED_STRLEN
#ifdef YY_USE_PROTOS
static int yy_flex_strlen( yyconst char *s )
#else
static int yy_flex_strlen( s )
yyconst char *s;
#endif
        {
        register int n;
        for ( n = 0; s[n]; ++n )
                ;

        return n;
        }
#endif


#ifdef YY_USE_PROTOS
static void *yy_flex_alloc( yy_size_t size )
#else
static void *yy_flex_alloc( size )
yy_size_t size;
#endif
        {
        return (void *) PAL_Malloc( size );
        }

#ifdef YY_USE_PROTOS
static void *yy_flex_realloc( void *ptr, yy_size_t size )
#else
static void *yy_flex_realloc( ptr, size )
void *ptr;
yy_size_t size;
#endif
        {
        /* The cast to (char *) in the following accommodates both
         * implementations that use char* generic pointers, and those
         * that use void* generic pointers.  It works with the latter
         * because both ANSI C and C++ allow castless assignment from
         * any pointer type to void*, and deal with argument conversions
         * as though doing an assignment.
         */
        return (void *) PAL_Realloc( (char *) ptr, size );
        }

#ifdef YY_USE_PROTOS
static void yy_flex_free( void *ptr )
#else
static void yy_flex_free( ptr )
void *ptr;
#endif
        {
        PAL_Free( ptr );
        }

#if YY_MAIN
int main()
        {
        yylex();
        return 0;
        }
#endif
#line 640 "mof.l"


/*
**==============================================================================
**
** Function definitions
**
**==============================================================================
*/

int yywrap()
{
    /* Return 1 to indicate the end of input */
    return 1;
}

static int exists(const char* path)
{
    if (access(path, R_OK) != 0)
        return -1;

    return 0;
}

static char* findIncludeFile(const char* path)
{
    /* First attempt to locate the file relative to the one that included it */
    {
        Buffer buf = BUFFER_INITIALIZER;
        char* p;

        p = strrchr(state.path, '/');

        if (p)
        {
            if (Buffer_Append(&buf, state.path, p - state.path + 1) != 0)
                return NULL;
        }

        if (Buffer_Append(&buf, path, strlen(path) + 1) != 0)
            return NULL;

        if (exists((const char*)buf.data) == 0)
            return (char*)buf.data;
    }

    /* Attempt to open the file relative to the current directory */
    {
        if (exists(path) == 0)
            return MOF_Strdup(&state.heap, path);
    }

    /* Search for file using include path array */
    {
        size_t i;
        for (i = 0; i < state.paths.size; i++)
        {
            const char* p = (const char*)state.paths.data[i];
            Buffer buf = BUFFER_INITIALIZER;

            if (Buffer_Append(&buf, p, strlen(p)) != 0)
                return NULL;

            if (Buffer_AppendChar(&buf, '/') != 0)
                return NULL;

            if (Buffer_Append(&buf, path, strlen(path) + 1) != 0)
                return NULL;

            if (exists((char*)buf.data) == 0)
                return (char*)buf.data;

            MOF_Free(&state.heap, buf.data);
        }
    }

    /* Not found */
    return NULL;
}

int openIncludeFile(const char* path_)
{
    FILE* is;
    char* path;

    if ((path = findIncludeFile(path_)) == NULL)
    {
        yyerrorf(ID_FAILED_TO_FIND_INCLUDE_FILE, 
            "failed to find inlude file: \"%s\"", path_);
        return -1;
    }

    /* Check for stack overflow. */
    if (s_top >= MOF_STACK_SIZE)
    {
        yyerrorf(ID_MOF_STACK_OVERFLOW, "MOF file stack overflow");
        return -1;
    }

    /* Open the file */
    if ((is = File_Open(path, "rb")) == NULL)
    {
        yyerrorf(ID_FAILED_TO_OPEN_FILE, "failed to open file: \"%s\"", path);
        return -1;
    }

    /* Push current state onto stack. */
    s_stack[s_top].file = state.path;
    s_stack[s_top].line = state.line;
    s_stack[s_top].buffer = YY_CURRENT_BUFFER;
    s_top++;

    /* Setup state for new file */
    yy_switch_to_buffer(yy_create_buffer(is, YY_BUF_SIZE));
    state.path = MOF_Strdup(&state.heap, path);
    state.line = 1;

    return 0;
}

int closeIncludeFile()
{
    /* Check for stack underflow. */
    if (s_top == 0)
    {
        yyerrorf(ID_MOF_STACK_UNDERFLOW, "MOF file stack underflow");
        return -1;
    }

    /* Release current state */
    MOF_Free(&state.heap, state.path);
    fclose(YY_CURRENT_BUFFER->yy_input_file);
    yy_delete_buffer(YY_CURRENT_BUFFER);

    /* Restore state from top of stack */
    s_top--;
    state.path = s_stack[s_top].file;
    state.line = s_stack[s_top].line;
    yy_switch_to_buffer(s_stack[s_top].buffer);

    return 0;
}

/*
**==============================================================================
**
** MOF_Parser
**
**==============================================================================
*/

MOF_Parser* MOF_Parser_New(
    const char* const* paths,
    size_t numPaths)
{
    MOF_Parser* self = (MOF_Parser*)PAL_Calloc(1, sizeof(MOF_Parser));
    size_t i;
    char* str;

    if (!self)
        return NULL;

    for (i = 0; i < numPaths; i++)
    {
        str = MOF_Strdup(&self->state.heap, paths[i]);

        if (!str)
        {
            MOF_Release(&self->state.heap);
            PAL_Free(self);
            return NULL;
        }

        /* PtrArray_Append() uses the global state's heap object to
         * obtain memory, so install self->state as the global state
         * object temporarily.
         */
        {
            state = self->state;
            PtrArray_Append(&state.paths, str);
            self->state = state;
            memset(&state, 0, sizeof(state));
        }
    }

    return self;
}

void MOF_Parser_SetErrorCallback(
    MOF_Parser* self, 
    void (*callback)(const char* msg, const wchar_t* wmsg, void* data),
    void* data)
{
    if (self)
    {
        self->state.errorCallback = callback;
        self->state.errorCallbackData = data;
    }
}

void MOF_Parser_SetWarningCallback(
    MOF_Parser* self, 
    void (*callback)(const char* msg, const wchar_t* wmsg, void* data),
    void* data)
{
    if (self)
    {
        self->state.warningCallback = callback;
        self->state.warningCallbackData = data;
    }
}

void MOF_Parser_SetPragmaCallback(
    MOF_Parser* self, 
    void (*callback)(const char* pragma, const char* value, void* data),
    void* data)
{
    if (self)
    {
        self->state.pragmaCallback = callback;
        self->state.pragmaCallbackData = data;
    }
}

void MOF_Parser_SetClassDeclCallback(
    MOF_Parser* self, 
    void (*callback)(const MI_ClassDecl* decl, void* data),
    void* data)
{
    if (self)
    {
        self->state.classDeclCallback = callback;
        self->state.classDeclCallbackData = data;
    }
}

void MOF_Parser_SetInstanceDeclCallback(
    MOF_Parser* self, 
    void (*callback)(const MI_InstanceDecl* decl, void* data),
    void* data)
{
    if (self)
    {
        self->state.instanceDeclCallback = callback;
        self->state.instanceDeclCallbackData = data;
    }
}

void MOF_Parser_SetQualifierDeclCallback(
    MOF_Parser* self, 
    void (*callback)(const MI_QualifierDecl* decl, void* data),
    void* data)
{
    if (self)
    {
        self->state.qualifierDeclCallback = callback;
        self->state.qualifierDeclCallbackData = data;
    }
}

void MOF_Parser_Delete(MOF_Parser* self)
{
    if (self)
    {
        MOF_Release(&self->state.heap);
        PAL_Free(self);
    }
}

/* Handle multiple calls to this function */
int MOF_Parser_Parse(MOF_Parser* self, const char* path)
{
    /* Reject null parameters */
    if (!self || !path)
        return -1;

    /* Clear stack */
    s_top = 0;

    /* Set global state */
    state = self->state;

    /* Open input */
    yyin = File_Open(path, "rb");

    if (!yyin)
    {
        yyerrorf(ID_FAILED_TO_OPEN_FILE, "failed to open file: %s", path);
        self->state = state;
        memset(&state.heap, 0, sizeof(state));
        return -1;
    }

    /* Save path */
    state.path = MOF_Strdup(&state.heap, path);

    /* Set initialize line number */
    state.line = 1;

    /* Clear the parser state */
    yy_c_buf_p = 0;
    yy_last_accepting_cpos = 0;
    yy_init = 1;

    /* Run the parser */
    if (yyparse() != 0)
    {
        fclose(yyin);
        yy_delete_buffer(YY_CURRENT_BUFFER);
        self->state = state;
        memset(&state.heap, 0, sizeof(state));
        return -1;
    }

    /* Perform post processing (which requires first pass completion) */
    if (PerformPostProcessing() != 0)
    {
        fclose(yyin);
        yy_delete_buffer(YY_CURRENT_BUFFER);
        self->state = state;
        memset(&state.heap, 0, sizeof(state));
        return -1;
    }

    /* Close stream and release parse buffer */
    fclose(yyin);
    yy_delete_buffer(YY_CURRENT_BUFFER);

    /* Restore state */
    self->state = state;
    memset(&state.heap, 0, sizeof(state));

    return 0;
}

/* Parse a MOF string */
int MOF_Parser_ParseString(MOF_Parser* self, const char* mof_string)
{
    YY_BUFFER_STATE bp;

    /* Reject null parameters */
    if (!self || !mof_string)
        return -1;

    /* Clear stack */
    s_top = 0;

    /* Set global state */
    state = self->state;

    /* Save path */
    state.path = MOF_Strdup(&state.heap, "MOF string");

    /* Set initialize line number */
    state.line = 1;

    /* Clear the parser state */
    yy_c_buf_p = 0;
    yy_last_accepting_cpos = 0;
    yy_init = 1;

    /* Run the parser */
    bp = yy_scan_string(mof_string);
    yy_switch_to_buffer(bp);
    if (yyparse() != 0)
    {
        yy_delete_buffer(bp);
        self->state = state;
        memset(&state.heap, 0, sizeof(state));
        return -1;
    }

    /* Perform post processing (which requires first pass completion) */
    if (PerformPostProcessing() != 0)
    {
        yy_delete_buffer(bp);
        self->state = state;
        memset(&state.heap, 0, sizeof(state));
        return -1;
    }

    /* Close stream and release parse buffer */
    yy_delete_buffer(bp);

    /* Restore state */
    self->state = state;
    memset(&state.heap, 0, sizeof(state));

    return 0;
}

void MOF_Parser_Dump(MOF_Parser* self, FILE* file)
{
    size_t i;

    for (i = 0; i < self->state.qualifierDecls.size; i++)
        MOF_PrintQualifierDecl(self->state.qualifierDecls.data[i], file);

    for (i = 0; i < self->state.classDecls.size; i++)
        MOF_PrintClassDecl(self->state.classDecls.data[i], file);

    for (i = 0; i < self->state.instanceDecls.size; i++)
        MOF_PrintInstanceDecl(self->state.instanceDecls.data[i], file);
}

void MOF_Parser_EnableExtensions(MOF_Parser* self, MI_Boolean enabled)
{
    self->state.extensionsEnabled = enabled;
    return;
}
